/* yForth? - A Forth interpreter written in ANSI C
 * Copyright (C) 2012 Luca Padovani
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 * ------------------------------------------------------------------------
 * Module name: toolse.c
 * Abstract:	Programming Tools extension word set
 */

#include <stdio.h>
#include <stdlib.h>
#include "yforth.h"
#include "toolse.h"
#include "core.h"
#include "coree.h"
#include "block.h"

/**************************************************************************/
/* WORDS ******************************************************************/
/**************************************************************************/

void _bye() {
#if BLOCK_DEF
	close_block_file();
#endif
    exit(0);
}

void _ahead() {
	compile_cell((Cell) _branch);
	*--sp = (Cell) _dp;
	compile_cell(0);
}

void _bracket_if() {
	register Cell flag = *sp++;
	register Cell nest = 1;
	register Cell ok = FFLAG(1);
	if (!flag) {
		do {
			_b_l();
			_word();
			sp++;
			if (!*_dp) {
				_refill();
				ok = *sp++;
			} else {
				if (!strmatch("[IF]", _dp, 4)) nest++;
				else if (!strmatch("[THEN]", _dp, 6) ||
						 (!strmatch("[ELSE]", _dp, 6) && nest == 1)) nest--;
			}
		} while (nest && ok);
	}
}

void _bracket_else() {
	register Cell nest = 1;
	register Cell ok = FFLAG(1);
	do {
		_b_l();
		_word();
		sp++;
		if (!*_dp) {
			_refill();
			ok = *sp++;
		} else {
			if (!strmatch("[IF]", _dp, 4)) nest++;
			else if (!strmatch("[THEN]", _dp, 6)) nest--;
		}
	} while (nest && ok);
}

void _bracket_then() {
}

